Index: /trunk/src/sys/arch/mips/mips/locore_mips1.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/locore_mips1.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/locore_mips1.S	(revision 152)
@@ -606,150 +1002,35 @@
  *----------------------------------------------------------------------------
  */
-NESTED_NOPROFILE(mips1_user_intr, CALLFRAME_SIZ, ra)
+LEAF_NOPROFILE(MIPSX(kern_tlb_miss))
 	.set	noat
-	.mask	0x80000000, -4
-/*
- * Save the relevant user registers onto the stack.
- * We don't need to save s0 - s8 because the compiler does it for us.
- */
-	lw	k1, CPUVAR(CURLWP)
-	nop
-	lw	k1, L_ADDR(k1)
-	nop
-	addu	k1, k1, USPACE - TF_SIZ
-	sw	AT, TF_REG_AST(k1)
-	sw	v0, TF_REG_V0(k1)
-	sw	v1, TF_REG_V1(k1)
-	mflo	v0
-	sw	a0, TF_REG_A0(k1)
-	sw	a1, TF_REG_A1(k1)
-	sw	a2, TF_REG_A2(k1)
-	sw	a3, TF_REG_A3(k1)
-	mfhi	v1
-	sw	t0, TF_REG_T0(k1)
-	sw	t1, TF_REG_T1(k1)
-	sw	t2, TF_REG_T2(k1)
-	sw	t3, TF_REG_T3(k1)
-	mfc0	a0, MIPS_COP_0_STATUS		# 1st arg is STATUS
-	sw	t4, TF_REG_T4(k1)
-	sw	t5, TF_REG_T5(k1)
-	sw	t6, TF_REG_T6(k1)
-	sw	t7, TF_REG_T7(k1)
-	mfc0	a1, MIPS_COP_0_CAUSE		# 2nd arg is CAUSE
-	sw	t8, TF_REG_T8(k1)
-	sw	t9, TF_REG_T9(k1)
-	sw	gp, TF_REG_GP(k1)
-	sw	sp, TF_REG_SP(k1)
-	mfc0	a2, MIPS_COP_0_EXC_PC		# 3rd arg is exception PC
-	sw	ra, TF_REG_RA(k1)
-	sw	a0, TF_REG_SR(k1)
-	sw	v0, TF_REG_MULLO(k1)
-	sw	v1, TF_REG_MULHI(k1)
-	and	a3, a0, a1			# 4th is STATUS & CAUSE
-	sw	a2, TF_REG_EPC(k1)
-	addu	sp, k1, -CALLFRAME_SIZ		# switch to kernel SP
-#ifdef __GP_SUPPORT__
-	la	gp, _C_LABEL(_gp)		# switch to kernel GP
-#endif
-	sw	MIPS_CURLWP, TF_MIPS_CURLWP(k1)	# save curlwp reg
-	lw	MIPS_CURLWP, CPUVAR(CURLWP)	# set curlwp reg
-	.set	at
-	and	t0, a0, ~MIPS_SR_COP_1_BIT	# turn off the FPU
-	.set	noat
-#if defined(DDB) || defined(DEBUG) || defined(KGDB)
-	move	ra, a2
-	sw	ra, CALLFRAME_RA(sp)		# for debugging
-#endif
-/*
- * Call the interrupt handler.
- */
-	jal	_C_LABEL(cpu_intr)
-	mtc0	t0, MIPS_COP_0_STATUS
-/*
- * Check pending asynchoronous traps.
- */
-	addu	a1, sp, CALLFRAME_SIZ
-	nop
-	lw	a0, TF_REG_SR(a1)
-	lw	v0, L_MD_ASTPENDING(MIPS_CURLWP)# any pending ast?
-	mtc0	a0, MIPS_COP_0_STATUS		# restore SR, disable intrs
-	beq	v0, zero, 1f			# if no, skip ast processing
-	lw	MIPS_CURLWP, TF_MIPS_CURLWP(a1) # restore curlwp reg
-/*
- * We have pending asynchronous traps; save remaining user state in stack. 
- */
-	sw	s0, TF_REG_S0(a1)
-	sw	s1, TF_REG_S1(a1)
-	sw	s2, TF_REG_S2(a1)
-	sw	s3, TF_REG_S3(a1)
-	sw	s4, TF_REG_S4(a1)
-	sw	s5, TF_REG_S5(a1)
-	sw	s6, TF_REG_S6(a1)
-	sw	s7, TF_REG_S7(a1)
-	sw	s8, TF_REG_S8(a1)
-
-	lw	a0, TF_REG_EPC(a1)		# argument is interrupted PC
-	li	t0, MIPS_HARD_INT_MASK | MIPS_SR_INT_IE
-	lw	MIPS_CURLWP, CPUVAR(CURLWP)	# set curlwp reg
-	jal	_C_LABEL(ast)
-	mtc0	t0, MIPS_COP_0_STATUS		# enable interrupts (spl0)
-
-	addu	a1, sp, CALLFRAME_SIZ
-	lw	a0, TF_REG_SR(a1)
-	lw	s0, TF_REG_S0(a1)
-	mtc0	a0, MIPS_COP_0_STATUS		# this should disable interrupts
-	lw	s1, TF_REG_S1(a1)
-	lw	s2, TF_REG_S2(a1)
-	lw	s3, TF_REG_S3(a1)
-	lw	s4, TF_REG_S4(a1)
-	lw	s5, TF_REG_S5(a1)
-	lw	s6, TF_REG_S6(a1)
-	lw	s7, TF_REG_S7(a1)
-	lw	s8, TF_REG_S8(a1)
-1:
-	lw	v0, TF_REG_MULLO(a1)
-	lw	v1, TF_REG_MULHI(a1)
-	mtlo	v0
-	mthi	v1
-	move	k1, a1
-	lw	k0, TF_REG_EPC(k1)		# exception PC
-	lw	AT, TF_REG_AST(k1)
-	lw	v0, TF_REG_V0(k1)
-	lw	v1, TF_REG_V1(k1)
-	lw	a0, TF_REG_A0(k1)
-	lw	a1, TF_REG_A1(k1)
-	lw	a2, TF_REG_A2(k1)
-	lw	a3, TF_REG_A3(k1)
-	lw	t0, TF_REG_T0(k1)
-	lw	t1, TF_REG_T1(k1)
-	lw	t2, TF_REG_T2(k1)
-	lw	t3, TF_REG_T3(k1)
-	lw	t4, TF_REG_T4(k1)
-	lw	t5, TF_REG_T5(k1)
-	lw	t6, TF_REG_T6(k1)
-	lw	t7, TF_REG_T7(k1)
-	lw	t8, TF_REG_T8(k1)
-	lw	t9, TF_REG_T9(k1)
-	lw	gp, TF_REG_GP(k1)
-	lw	sp, TF_REG_SP(k1)
-	lw	ra, TF_REG_RA(k1)
-	j	k0				# return to interrupted point
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR	# get the fault address
+	li	k1, VM_MIN_KERNEL_ADDRESS	# compute index
+	PTR_SUBU k0, k1
+	INT_L	k1, _C_LABEL(Sysmapsize)	# index within range?
+	PTR_SRL	k0, PGSHIFT
+	sltu	k1, k0, k1
+	/*
+	 * If we are beyond the bounds of Sysmap, let trap panic for us.
+	 */
+	beqz	k1, _C_LABEL(MIPSX(kern_gen_exception))	# full trap processing
+	 nop					# - delay slot -
+	PTR_L	k1, _C_LABEL(Sysmap)
+	PTR_SLL	k0, 2				# compute offset from index
+	PTR_ADDU k1, k0
+	INT_L	k0, 0(k1)			# get PTE entry
+	_MFC0	k1, MIPS_COP_0_EXC_PC		# get return address
+	mtc0	k0, MIPS_COP_0_TLB_LOW		# save PTE entry
+	and	k0, MIPS1_PG_V			# check for valid PTE entry
+	beqz	k0, _C_LABEL(MIPSX(kern_gen_exception)) # PTE invalid
+	 nop
+	tlbwr					# write random TLB
+	j	k1
 	rfe
-	.set	at
-END(mips1_user_intr)
-
-/*
- * Mark where code entreed from exception hander jumptable
- * ends, for stack traceback code.
- */
-
-	.globl	_C_LABEL(mips1_exceptionentry_end)
-_C_LABEL(mips1_exceptionentry_end):
-
+END(MIPSX(kern_tlb_miss))
 
 #if 0
 /*----------------------------------------------------------------------------
  *
- * mips1_tlb_modexception --
+ * mipsN_tlb_invalid_exception --
  *
  *	Handle a TLB modified exception.
@@ -765,5 +1046,5 @@
  *----------------------------------------------------------------------------
  */
-LEAF_NOPROFILE(mips1_tlb_mod_exception)
+LEAF_NOPROFILE(MIPSX(tlb_mod_exception))
 	.set	noat
 	tlbp					# find the TLB entry
@@ -774,13 +1055,13 @@
 	mtc0	k0, MIPS_COP_0_TLB_LOW
 	li	k1, MIPS_KSEG0_START
-	subu	k0, k0, k1
+	PTR_SUBU k0, k1
 	srl	k0, k0, MIPS1_TLB_PHYS_PAGE_SHIFT
-	la	k1, pmap_attributes		# DANGER!  DANGER!
-	addu	k0, k0, k1
+	PTR_L	k1, pmap_attributes		# DANGER!  DANGER!
+	PTR_ADDU k0, k1
 	lbu	k1, 0(k0)			# fetch old value
 	nop
 	or	k1, k1, 1			# set modified bit
 	sb	k1, 0(k0)			# save new value
-	mfc0	k0, MIPS_COP_0_EXC_PC		# get return address
+	_MFC0	k0, MIPS_COP_0_EXC_PC		# get return address
 	nop
 	j	k0
@@ -789,14 +1070,22 @@
 	break	0				# panic
 	.set	at
-END(mips1_TLBModException)
+END(MIPSX(tlb_mod_exception))
 #endif
 
-/*----------------------------------------------------------------------------
- *
- * mips1_tlb_miss_exception --
- *
- *	Handle a TLB miss exception from kernel mode.
- *	The BaddVAddr, Context, and EntryHi registers contain the failed
- *	virtual address.
+/*
+ * Mark where code entreed from exception hander jumptable
+ * ends, for stack traceback code.
+ */
+
+	.globl	_C_LABEL(MIPSX(exceptionentry_end))
+_C_LABEL(MIPSX(exceptionentry_end)):
+
+/*--------------------------------------------------------------------------
+ *
+ * mipsN_tlb_set_asid --
+ *
+ *	Write the given pid into the TLB pid reg.
+ *
+ *	void mipsN_tlb_set_asid(uint32_t pid)
  *
  * Results:
@@ -804,74 +1093,25 @@
  *
  * Side effects:
- *	None.
- *
- *----------------------------------------------------------------------------
- */
-LEAF_NOPROFILE(mips1_tlb_miss_exception)
-	.set	noat
-	mfc0	k0, MIPS_COP_0_BAD_VADDR	# get the fault address
-	li	k1, VM_MIN_KERNEL_ADDRESS	# compute index
-	subu	k0, k0, k1
-	lw	k1, _C_LABEL(Sysmapsize)	# index within range?
-	srl	k0, k0, PGSHIFT
-	sltu	k1, k0, k1
-	beq	k1, zero, outofworld		# No. falling beyond...
-	nop
-	lw	k1, _C_LABEL(Sysmap)
-	sll	k0, k0, 2			# compute offset from index
-	addu	k1, k1, k0
-	lw	k0, 0(k1)			# get PTE entry
-	mfc0	k1, MIPS_COP_0_EXC_PC		# get return address
-	mtc0	k0, MIPS_COP_0_TLB_LOW		# save PTE entry
-	and	k0, k0, MIPS1_PG_V		# check for valid entry
-	beq	k0, zero, _C_LABEL(mips1_kern_gen_exception) # PTE invalid
-	nop
-	tlbwr					# update TLB
-	j	k1
-	rfe
-
-outofworld:
-	/* Ensure we have a valid sp so panic has a chance */
-	move	a1, sp
-	la	sp, start			# set sp to a valid place
-	PANIC("TLB out of universe: ksp was %p")
-	.set	at
-END(mips1_tlb_miss_exception)
-
-
-/*--------------------------------------------------------------------------
- *
- * mips1_tlb_set_asid --
- *
- *	Write the given pid into the TLB pid reg.
- *
- *	void mips1_tlb_set_asid(uint32_t pid)
- *
- * Results:
- *	None.
- *
- * Side effects:
  *	PID set in the entry hi register.
  *
  *--------------------------------------------------------------------------
  */
-LEAF(mips1_tlb_set_asid)
-	sll	a0, a0, MIPS1_TLB_PID_SHIFT	# put PID in right spot
+LEAF(MIPSX(tlb_set_asid))
+	sll	a0, MIPS1_TLB_PID_SHIFT		# put PID in right spot
 	mtc0	a0, MIPS_COP_0_TLB_HI		# Write the hi reg value
 	j	ra
 	nop
-END(mips1_tlb_set_asid)
-
+END(MIPSX(tlb_set_asid))
 
 /*--------------------------------------------------------------------------
  *
- * mips1_TLBUpdate --
- *
- *	Update the TLB if highreg is found; otherwise, enter the data.
- *
- *	mips1_tlb_update(register_t highreg, register_t lowreg)
+ * mipsN_tlb_update --
+ *
+ *	Update the TLB if highreg is found; otherwise, do_nothing
+ *
+ *	int mipsN_tlb_update(vaddr_t va, register_t lowreg)
  *
  * Results:
- *	None.
+ *	< 0 if skipped, >= 0 if updated
  *
  * Side effects:
@@ -880,5 +1120,5 @@
  *--------------------------------------------------------------------------
  */
-LEAF(mips1_tlb_update)
+LEAF(MIPSX(tlb_update))
 	mfc0	v1, MIPS_COP_0_STATUS		# save the status register
 	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
@@ -891,35 +1131,32 @@
 	mfc0	v0, MIPS_COP_0_TLB_INDEX	# see what we got
 	mtc0	a1, MIPS_COP_0_TLB_LOW		# set new entrylo
-	bgez	v0, 2f				# index < 0 => !found
-	 nop
-	b	3f
-	 tlbwr					# add vicitimizing another
+	bltz	v0, 2f				# index < 0 => !found
+	 nop
+	tlbwi					# update slot found
 2:
-	tlbwi					# update the existing one
-3:
 	mtc0	t0, MIPS_COP_0_TLB_HI		# restore current PID
 	j	ra
 	mtc0	v1, MIPS_COP_0_STATUS
-END(mips1_tlb_update)
+END(MIPSX(tlb_update))
 
 /*--------------------------------------------------------------------------
  *
- * mips1_tlb_read_indexed --
+ * mipsN_tlb_read_indexed --
  *
  *	Read the TLB entry.
  *
- *	mips1_tlb_read_indexed(register_t entry, struct mips1_tlb *tlb)
+ *	void mipsN_tlb_read_indexed(register_t entry, struct tlbmask *tlb)
  *
  * Results:
- *	Returns MIPS1 TLB HI/LO in a pair.
+ *	tlb will contain the TLB entry found (tlb_lo1/tlb_mask will be 0).
  *
  *--------------------------------------------------------------------------
  */
-LEAF(mips1_tlb_read_indexed)
+LEAF(MIPSX(tlb_read_indexed))
 	mfc0	v1, MIPS_COP_0_STATUS		# Save the status register.
 	mtc0	zero, MIPS_COP_0_STATUS		# Disable interrupts
 	mfc0	t0, MIPS_COP_0_TLB_HI		# Get current PID
 
-	sll	a0, a0, MIPS1_TLB_INDEX_SHIFT
+	sll	a0, MIPS1_TLB_INDEX_SHIFT
 	mtc0	a0, MIPS_COP_0_TLB_INDEX	# Set the index register
 	nop
@@ -927,16 +1164,435 @@
 	mfc0	t2, MIPS_COP_0_TLB_HI		# fetch the hi entry
 	mfc0	t3, MIPS_COP_0_TLB_LOW		# fetch the low entry
-	sw	t2, TLBMASK_HI(a1)
-	sw	t3, TLBMASK_LO0(a1)
-	sw	zero, TLBMASK_LO1(a1)
-	sw	zero, TLBMASK_MASK(a1)
+
+	mtc0	t0, MIPS_COP_0_TLB_HI		# Restore proper PID
+						# (before touching memory)
+	mtc0	v1, MIPS_COP_0_STATUS		# Restore the status register
+
+	PTR_S	t2, TLBMASK_HI(a1)
+	INT_S	t3, TLBMASK_LO0(a1)
+	INT_S	zero, TLBMASK_LO1(a1)
+	j	ra
+	 INT_S	zero, TLBMASK_MASK(a1)
+END(MIPSX(tlb_read_indexed))
+
+/*--------------------------------------------------------------------------
+ *
+ * mipsX_tlb_write_indexed --
+ *
+ *	Write the TLB entry.
+ *
+ *	void mipsX_tlb_write_indexed(size_t entry, struct tlbmask *tlb)
+ *
+ * Results:
+ *	None.
+ *
+ *--------------------------------------------------------------------------
+ */
+LEAF(MIPSX(tlb_write_indexed))
+	PTR_L	t2, TLBMASK_HI(a1)		# fetch the hi entry
+	INT_L	t3, TLBMASK_LO0(a1)		# fetch the low entry
+	mfc0	v1, MIPS_COP_0_STATUS		# Save the status register.
+	mtc0	zero, MIPS_COP_0_STATUS		# Disable interrupts
+	mfc0	t0, MIPS_COP_0_TLB_HI		# Get current PID
+
+	sll	a0, MIPS1_TLB_INDEX_SHIFT
+	mtc0	a0, MIPS_COP_0_TLB_INDEX	# Set the index register
+	nop
+	mtc0	t2, MIPS_COP_0_TLB_HI		
+	mtc0	t3, MIPS_COP_0_TLB_LOW		
+	
+	tlbwi					# Write to the TLB entry
 
 	mtc0	t0, MIPS_COP_0_TLB_HI		# restore PID
 	j	ra
-	mtc0	v1, MIPS_COP_0_STATUS		# Restore the status register
-END(mips1_tlb_read_indexed)
+	 mtc0	v1, MIPS_COP_0_STATUS		# Restore the status register
+END(MIPSX(tlb_write_indexed))
+
+/*
+ * void mipsN_tlb_invalidate_addr(vaddr_t va)
+ *
+ * Invalidate a TLB entry for given virtual address if found in TLB.
+ */
+LEAF(MIPSX(tlb_invalidate_addr))
+	mfc0	v1, MIPS_COP_0_STATUS		# save status register
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+	mfc0	t0, MIPS_COP_0_TLB_HI		# save current PID
+	nop
+
+	mtc0	a0, MIPS_COP_0_TLB_HI		# look for addr & PID
+	nop
+	tlbp					# probe the entry in question
+	mfc0	a0, MIPS_COP_0_TLB_INDEX	# see what we got
+	li	t1, MIPS_KSEG0_START		# load invalid address
+	bltz	a0, 1f				# index < 0 then skip
+	 nop
+	mtc0	t1, MIPS_COP_0_TLB_HI		# make entryHi invalid
+	mtc0	zero, MIPS_COP_0_TLB_LOW	# zero out entryLo
+	nop
+	tlbwi
+1:
+	mtc0	t0, MIPS_COP_0_TLB_HI		# restore PID
+	j	ra
+	 mtc0	v1, MIPS_COP_0_STATUS		# restore the status register
+END(MIPSX(tlb_invalidate_addr))
+
+/*
+ * void mipsN_tlb_invalidate_asids(uint32_t asid_lo, uint32_t asid_hi)
+ *
+ * Invalidate TLB entries belonging to asids (asid_lo,asid_hi]
+ * leaving entries for kernel space marked global intact.
+ */
+LEAF(MIPSX(tlb_invalidate_asids))
+	mfc0	t3, MIPS_COP_0_TLB_HI		# save EntryHi
+	mfc0	v1, MIPS_COP_0_STATUS		# save status register
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+
+	INT_L	t2, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
+	li	t1, MIPS1_TLB_FIRST_RAND_ENTRY << MIPS1_TLB_INDEX_SHIFT
+	li	v0, MIPS_KSEG0_START		# invalid address
+	sll	t2, MIPS1_TLB_INDEX_SHIFT
+
+	# do {} while (t1 < t2)
+1:
+	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set index
+	nop
+	tlbr					# obtain an entry
+	mfc0	ta0, MIPS_COP_0_TLB_LOW
+	nop
+	and	ta0, ta0, MIPS1_PG_G		# check to see it has G bit
+	bnez	ta0, 2f
+	 nop
+
+	mfc0	ta0, MIPS_COP_0_TLB_HI		# get va and ASID
+	nop
+	and	ta0, ta0, PG_ASID		# mask off ASID
+	sltu	ta1, ta0, a0			# < asid_lo
+	bnez	ta1, 2f				# yes, next tlb entry
+	 nop
+	sltu	ta2, ta0, a1			# < asid_hi
+	beqz	ta2, 2f				# no, next tlb entry
+	 nop
+
+	mtc0	v0, MIPS_COP_0_TLB_HI		# make entryHi invalid
+	mtc0	zero, MIPS_COP_0_TLB_LOW	# zero out entryLo
+	nop
+	tlbwi					# invalidate the TLB entry
+2:
+	addu	t1, t1, 1 << MIPS1_TLB_INDEX_SHIFT	# increment index
+	bne	t1, t2, 1b
+	nop
+
+	mtc0	t3, MIPS_COP_0_TLB_HI		# restore entryHi
+
+	j	ra				# new TLBpid will be set soon
+	 mtc0	v1, MIPS_COP_0_STATUS		# restore status register
+END(MIPSX(tlb_invalidate_asids))
+
+/*
+ * void mipsN_tlb_invalidate_all(void)
+ *
+ * Invalidate TLB entirely.
+ */
+LEAF(MIPSX(tlb_invalidate_all))
+	INT_L	a0, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
+
+	mfc0	v1, MIPS_COP_0_STATUS		# save the status register.
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+
+	li	t1, MIPS_KSEG0_START
+	mtc0	t1, MIPS_COP_0_TLB_HI		# make entryHi invalid
+	mtc0	zero, MIPS_COP_0_TLB_LOW	# zero out entryLo
+
+	move	t1, zero
+	sll	a0, MIPS1_TLB_INDEX_SHIFT
+
+	# do {} while (t1 < a0)
+1:
+	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set TLBindex
+	addu	t1, t1, 1 << MIPS1_TLB_INDEX_SHIFT	# increment index
+	bne	t1, a0, 1b
+	 tlbwi					# invalidate the entry
+
+	j	ra
+	 mtc0	v1, MIPS_COP_0_STATUS		# restore status register
+END(MIPSX(tlb_invalidate_all))
+
+/*
+ * u_int mipsN_tlb_record_asids(u_long *bitmap, uint32_t asid_mask)
+ *
+ * Scan the random part of the TLB looking at non-global entries and
+ * record each ASID in use into the bitmap.  Additionally, return the
+ * number of new unique ASIDs encountered.
+ */
+LEAF(MIPSX(tlb_record_asids))
+	mfc0	ta3, MIPS_COP_0_TLB_HI		# save EntryHi
+	li	ta0, MIPS1_TLB_FIRST_RAND_ENTRY << MIPS1_TLB_INDEX_SHIFT
+	INT_L	ta1, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
+	move	ta2, zero
+	li	ta3, 1
+	sll	ta1, MIPS1_TLB_INDEX_SHIFT
+
+	mfc0	v1, MIPS_COP_0_STATUS		# save status register
+	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
+
+	move	v0, zero			# start at zero ASIDs
+
+	# do {} while (ta0 < ta1)
+1:
+	mtc0	ta0, MIPS_COP_0_TLB_INDEX	# set index
+	nop
+	tlbr					# obtain an entry
+	mfc0	t0, MIPS_COP_0_TLB_LOW
+	nop
+	and	t0, MIPS1_PG_G			# check to see it has G bit
+	bnez	t0, 4f
+	 nop
+
+	mfc0	t0, MIPS_COP_0_TLB_HI		# get va and ASID
+	nop
+	and	t0, PG_ASID			# mask off ASID
+	srl	t0, MIPS1_TLB_INDEX_SHIFT	# shift to low bits
+
+	srl	a2, t0, 3 + LONG_SCALESHIFT	# drop low 5 bits
+	sll	a2, LONG_SCALESHIFT		# make an index for the bitmap
+	sllv	t0, ta3, t0			# t0 is mask (ta3 = 1)
+
+	PTR_ADDU a2, a0				# index into the bitmap
+	beq	a2, ta2, 3f			# is the desired cell loaded?
+	 nop					#   yes, don't reload it
+	beqz	ta2, 2f				# has is ever been loaded?
+	 nop					#   nope, so don't have it
+
+	LONG_S	t2, 0(ta2)			# save the updated value
+2:
+	LONG_L	t2, 0(a2)			# and load it
+	 move	ta2, a2				# remember the new cell's addr
+3:
+	and	t1, t2, t0			# see if this asid was recorded
+	sltu	t1, t1, ta3			# t1 = t1 < 1 (aka t1 == 0)
+	addu	v0, t1				# v0 += t1 
+	or	t2, t0				# or in the new ASID bit
+
+4:
+	addu	ta0, 1 << MIPS1_TLB_INDEX_SHIFT	# increment TLB entry #
+	bne	ta0, ta1, 1b			# keep looking if not at limit
+	 nop
+
+	beqz	ta2, 5f				# do we have a cell to write?
+	 nop					#   nope, nothing.
+
+	LONG_S	t2, 0(ta2)			# save the updated valu.
+5:
+	mtc0	a3, MIPS_COP_0_TLB_HI		# restore entryHi
+
+	j	ra				# new TLBpid will be set soon
+	 mtc0	v1, MIPS_COP_0_STATUS		# restore status register
+END(MIPSX(tlb_record_asids))
+
+/*--------------------------------------------------------------------------
+ *
+ * mipsN_tlb_enter --
+ *
+ *	Entr the 
+ *
+ *	mipsN_tlb_enter(size_t tlb_index, vaddr_t va_asid, uint32_t tlb_lo)
+ *
+ * Results:
+ *	None.
+ *
+ * Side effects:
+ *	None.
+ *
+ *--------------------------------------------------------------------------
+ */
+LEAF(MIPSX(tlb_enter))
+	mfc0	t0, MIPS_COP_0_TLB_HI		# save current PID
+	nop
+	mtc0	a0, MIPS_COP_0_TLB_HI		# set entryhi
+	nop
+	tlbp					# probe the existence
+	mfc0	v0, MIPS_COP_0_TLB_INDEX	# see what we got
+	nop
+	bltz	v0, 2f				# index < 0 => !found
+	 nop
+	beq	v0, a0, 3f
+	 nop
+	li	t1, MIPS_KSEG0_START
+	mtc0	t1, MIPS_COP_0_TLB_HI		# set invalid address
+	nop
+	mtc0	zero, MIPS_COP_0_TLB_LOW	# set invalid entrylo
+	nop
+	tlbwi					# invalidate the old entry
+
+	mtc0	a1, MIPS_COP_0_TLB_HI		# set entryhi
+	nop
+2:
+	mtc0	a0, MIPS_COP_0_TLB_INDEX	# set the new location
+	nop
+3:
+	mtc0	a2, MIPS_COP_0_TLB_LOW		# set new entrylo
+	nop
+	tlbwi					# update the existing one
+3:
+	j	ra
+	 mtc0	t0, MIPS_COP_0_TLB_HI		# restore current PID
+END(MIPSX(tlb_enter))
 
 /*----------------------------------------------------------------------------
  *
+ *	R3000 trampolines and context resume
+ *
+ *----------------------------------------------------------------------------
+ */
+
+/*----------------------------------------------------------------------------
+ *
+ * mipsN_lwp_trampoline
+ *
+ * Special arrangement for a process about to go user mode right after
+ * fork() system call.  When the first CPU tick is scheduled to run the
+ * forked child, it starts running from here.  Then, a service function
+ * is called with one argument supplied to complete final preparations,
+ * and the process returns to user mode as if the fork() system call is
+ * handled in a normal way.  No need to save any registers although this
+ * calls another.
+ *----------------------------------------------------------------------------
+ */
+LEAF(MIPSX(lwp_trampoline))
+	PTR_ADDU sp, -CALLFRAME_SIZ
+
+	# Call lwp_startup(), with args from cpu_switchto()/cpu_setfunc()
+	move	a0, v0
+	jal	_C_LABEL(lwp_startup)
+	 move	a1, MIPS_CURLWP
+
+	# Call the routine specified by cpu_setfunc()
+	jalr	s0			
+	 move	a0, s1
+
+	# Return to user (won't happen if a kernel thread)
+	.set	noat
+MIPSX(user_return):
+	REG_L	s0, CALLFRAME_SIZ+TF_REG_S0(sp)	# $16
+	REG_L	s1, CALLFRAME_SIZ+TF_REG_S1(sp)	# $16
+	REG_L	s2, CALLFRAME_SIZ+TF_REG_S2(sp)	# $16
+	REG_L	s3, CALLFRAME_SIZ+TF_REG_S3(sp)	# $16
+	REG_L	s4, CALLFRAME_SIZ+TF_REG_S4(sp)	# $16
+	REG_L	s5, CALLFRAME_SIZ+TF_REG_S5(sp)	# $16
+	REG_L	s6, CALLFRAME_SIZ+TF_REG_S6(sp)	# $16
+	REG_L	s7, CALLFRAME_SIZ+TF_REG_S7(sp)	# $16
+	REG_L	s8, CALLFRAME_SIZ+TF_REG_S8(sp)	# $30
+MIPSX(user_intr_return):
+	REG_L	a0, CALLFRAME_SIZ+TF_REG_SR(sp)
+	REG_L	t0, CALLFRAME_SIZ+TF_REG_MULLO(sp)
+	REG_L	t1, CALLFRAME_SIZ+TF_REG_MULHI(sp)
+	mtc0	a0, MIPS_COP_0_STATUS	# this should disable interrupts
+	mtlo	t0
+	mthi	t1
+	move	k1, sp
+	REG_L	AT, TF_BASE+TF_REG_AST(sp)
+	REG_L	k0, CALLFRAME_SIZ+TF_REG_EPC(k1)
+	REG_L	AT, CALLFRAME_SIZ+TF_REG_AST(k1)
+	REG_L	v0, CALLFRAME_SIZ+TF_REG_V0(k1)
+	REG_L	v1, CALLFRAME_SIZ+TF_REG_V1(k1)
+	REG_L	a0, CALLFRAME_SIZ+TF_REG_A0(k1)
+	REG_L	a1, CALLFRAME_SIZ+TF_REG_A1(k1)
+	REG_L	a2, CALLFRAME_SIZ+TF_REG_A2(k1)
+	REG_L	a3, CALLFRAME_SIZ+TF_REG_A3(k1)
+	REG_L	t0, CALLFRAME_SIZ+TF_REG_T0(k1)
+	REG_L	t1, CALLFRAME_SIZ+TF_REG_T1(k1)
+	REG_L	t2, CALLFRAME_SIZ+TF_REG_T2(k1)
+	REG_L	t3, CALLFRAME_SIZ+TF_REG_T3(k1)
+	REG_L	ta0, CALLFRAME_SIZ+TF_REG_TA0(k1)
+	REG_L	ta1, CALLFRAME_SIZ+TF_REG_TA1(k1)
+	REG_L	ta2, CALLFRAME_SIZ+TF_REG_TA2(k1)
+	REG_L	ta3, CALLFRAME_SIZ+TF_REG_TA3(k1)
+	REG_L	t8, CALLFRAME_SIZ+TF_REG_T8(k1)
+	REG_L	t9, CALLFRAME_SIZ+TF_REG_T9(k1)
+	REG_L	gp, CALLFRAME_SIZ+TF_REG_GP(k1)
+	REG_L	ra, CALLFRAME_SIZ+TF_REG_RA(k1)
+	REG_L	sp, CALLFRAME_SIZ+TF_REG_SP(k1)
+	nop
+	j	k0
+	rfe
+	.set	at
+END(MIPSX(lwp_trampoline))
+
+/*
+ * Like lwp_trampoline, but do not call lwp_startup
+ */
+LEAF(MIPSX(setfunc_trampoline))
+	PTR_ADDU sp, -CALLFRAME_SIZ
+
+	# Call the routine specified by cpu_setfunc()
+	PTR_LA	ra, MIPSX(user_return)
+	jr	s0			
+	 move	a0, s1
+END(MIPSX(setfunc_trampoline))
+
+/*
+ * void mipsN_cpu_switch_resume(struct lwp *newlwp)
+ *
+ * Wiredown the USPACE of newproc with TLB entry#0 and #1.  Check
+ * if target USPACE is already refered by any TLB entry before
+ * doing that, and make sure TBIS(them) in the case.
+ */
+LEAF_NOPROFILE(MIPSX(cpu_switch_resume))
+	INT_L	a1, L_MD_UPTE_0(a0)		# a1 = upte[0]
+	INT_L	a2, L_MD_UPTE_1(a0)		# a2 = upte[1]
+	PTR_L	s0, L_PCB(a0)			# va = l->l_addr
+	li	s2, VM_MIN_KERNEL_ADDRESS
+	blt	s0, s2, resume
+	nop
+
+	mtc0	s0, MIPS_COP_0_TLB_HI		# VPN = va
+	nop
+	tlbp					# probe 1st VPN
+	mfc0	s1, MIPS_COP_0_TLB_INDEX
+	nop
+	bltz	s1, entry0set
+	li	s1, MIPS_KSEG0_START		# found, then
+	mtc0	s1, MIPS_COP_0_TLB_HI
+	mtc0	zero, MIPS_COP_0_TLB_LOW
+	nop
+	tlbwi					# TBIS(va)
+	nop
+	mtc0	s0, MIPS_COP_0_TLB_HI		# set 1st VPN again
+entry0set:
+	mtc0	zero, MIPS_COP_0_TLB_INDEX	# TLB index #0
+	ori	a1, a1, MIPS1_PG_G
+	mtc0	a1, MIPS_COP_0_TLB_LOW		# 1st PFN w/ PG_G
+	nop
+	tlbwi					# set TLB entry #0
+
+	addu	s0, s0, PAGE_SIZE
+	mtc0	s0, MIPS_COP_0_TLB_HI		# VPN = va+PAGE_SIZE
+	nop
+	tlbp					# probe 2nd VPN
+	mfc0	s1, MIPS_COP_0_TLB_INDEX
+	nop
+	bltz	s1, entry1set
+	li	s1, MIPS_KSEG0_START		# found, then
+	mtc0	s1, MIPS_COP_0_TLB_HI
+	mtc0	zero, MIPS_COP_0_TLB_LOW
+	nop
+	tlbwi					# TBIS(va+PAGE_SIZE)
+	nop
+	mtc0	s0, MIPS_COP_0_TLB_HI		# set 2nd VPN again
+entry1set:
+	li	s1, 1 << MIPS1_TLB_INDEX_SHIFT
+	mtc0	s1, MIPS_COP_0_TLB_INDEX	# TLB index #1
+	ori	a2, a2, MIPS1_PG_G
+	mtc0	a2, MIPS_COP_0_TLB_LOW		# 2nd PFN w/ PG_G
+	nop
+	tlbwi					# set TLB entry #1
+
+resume:
+	j	ra
+	nop
+END(MIPSX(cpu_switch_resume))
+
+/*----------------------------------------------------------------------------
+ *
  *	R3000 cache sizing and flushing code.
  *
@@ -945,5 +1601,5 @@
 #ifndef ENABLE_MIPS_TX3900
 /*
- * void mips1_wbflush(void)
+ * void mipsN_wbflush(void)
  *
  * Drain processor's write buffer, normally used to ensure any I/O
@@ -959,5 +1615,5 @@
  * differently.
  */
-LEAF(mips1_wbflush)
+LEAF(MIPSX(wbflush))
 	nop
 	nop
@@ -968,5 +1624,5 @@
 	j	ra
 	nop
-END(mips1_wbflush)
+END(MIPSX(wbflush))
 #else /* !ENABLE_MIPS_TX3900 */
 /*
@@ -1008,8 +1664,8 @@
 	mfc0	v0, R3900_COP_0_CONFIG
 	j	ra
-	nop
+	 nop
 END(tx3900_cp0_config_read)
 
-LEAF(mips1_wbflush)
+LEAF(MIPSX(wbflush))
 	.set push
 	.set mips2
